import DashboardControl from "devexpress-dashboard/integration/index";
import { createComponent } from "devextreme-vue/core/index";
import { createConfigurationComponent } from "devextreme-vue/core/index";
const DxDashboardControl = createComponent({
    props: {
        ajaxRemoteService: Object,
        allowMaximizeItems: Boolean,
        dashboardId: String,
        dataRequestOptions: Object,
        encodeHtml: Boolean,
        endpoint: String,
        extensions: Object,
        fetchRemoteService: Object,
        initialDashboardId: String,
        initialDashboardState: String,
        limitVisibleDataMode: String,
        loadDefaultDashboard: Boolean,
        nonce: String,
        onBeforeRender: Function,
        onDashboardBeginUpdate: Function,
        onDashboardEndUpdate: Function,
        onDashboardInitialized: Function,
        onDashboardInitializing: Function,
        onDashboardStateChanged: Function,
        onInitializing: Function,
        onItemBeginUpdate: Function,
        onItemEndUpdate: Function,
        onOptionChanged: Function,
        resizeByTimer: Boolean,
        showConfirmationOnBrowserClosing: Boolean,
        useNeutralFilterMode: Boolean,
        workingMode: String
    },
    emits: {
        "update:isActive": null,
        "update:hoveredElement": null,
        "update:ajaxRemoteService": null,
        "update:allowMaximizeItems": null,
        "update:dashboardId": null,
        "update:dataRequestOptions": null,
        "update:encodeHtml": null,
        "update:endpoint": null,
        "update:extensions": null,
        "update:fetchRemoteService": null,
        "update:initialDashboardId": null,
        "update:initialDashboardState": null,
        "update:limitVisibleDataMode": null,
        "update:loadDefaultDashboard": null,
        "update:nonce": null,
        "update:onBeforeRender": null,
        "update:onDashboardBeginUpdate": null,
        "update:onDashboardEndUpdate": null,
        "update:onDashboardInitialized": null,
        "update:onDashboardInitializing": null,
        "update:onDashboardStateChanged": null,
        "update:onInitializing": null,
        "update:onItemBeginUpdate": null,
        "update:onItemEndUpdate": null,
        "update:onOptionChanged": null,
        "update:resizeByTimer": null,
        "update:showConfirmationOnBrowserClosing": null,
        "update:useNeutralFilterMode": null,
        "update:workingMode": null,
    },
    computed: {
        instance() {
            return this.$_instance;
        }
    },
    beforeCreate() {
        this.$_WidgetClass = DashboardControl;
        this.$_hasAsyncTemplate = true;
        this.$_expectedChildren = {
            ajaxRemoteService: { isCollectionItem: false, optionName: "ajaxRemoteService" },
            dataRequestOptions: { isCollectionItem: false, optionName: "dataRequestOptions" },
            extensions: { isCollectionItem: false, optionName: "extensions" },
            fetchRemoteService: { isCollectionItem: false, optionName: "fetchRemoteService" }
        };
    }
});
const DxAjaxRemoteService = createConfigurationComponent({
    emits: {
        "update:isActive": null,
        "update:hoveredElement": null,
        "update:beforeSend": null,
        "update:complete": null,
        "update:headers": null,
    },
    props: {
        beforeSend: Function,
        complete: Function,
        headers: Object
    }
});
DxAjaxRemoteService.$_optionName = "ajaxRemoteService";
const DxChartIndicators = createConfigurationComponent({
    emits: {
        "update:isActive": null,
        "update:hoveredElement": null,
        "update:customIndicatorTypes": null,
    },
    props: {
        customIndicatorTypes: Object
    }
});
DxChartIndicators.$_optionName = "chartIndicators";
const DxDashboardExport = createConfigurationComponent({
    emits: {
        "update:isActive": null,
        "update:hoveredElement": null,
        "update:allowExportDashboard": null,
        "update:allowExportDashboardItems": null,
        "update:onExportDialogHidden": null,
        "update:onExportDialogShowing": null,
        "update:onExportDialogShown": null,
    },
    props: {
        allowExportDashboard: Boolean,
        allowExportDashboardItems: Boolean,
        onExportDialogHidden: Function,
        onExportDialogShowing: Function,
        onExportDialogShown: Function
    }
});
DxDashboardExport.$_optionName = "dashboardExport";
const DxDashboardParameterDialog = createConfigurationComponent({
    emits: {
        "update:isActive": null,
        "update:hoveredElement": null,
        "update:onDynamicLookUpValuesLoaded": null,
        "update:onHidden": null,
        "update:onShowing": null,
        "update:onShown": null,
    },
    props: {
        onDynamicLookUpValuesLoaded: Function,
        onHidden: Function,
        onShowing: Function,
        onShown: Function
    }
});
DxDashboardParameterDialog.$_optionName = "dashboardParameterDialog";
const DxDataInspector = createConfigurationComponent({
    emits: {
        "update:isActive": null,
        "update:hoveredElement": null,
        "update:allowInspectAggregatedData": null,
        "update:allowInspectRawData": null,
        "update:onDialogHidden": null,
        "update:onDialogShowing": null,
        "update:onDialogShown": null,
        "update:onGridContentReady": null,
        "update:onGridInitialized": null,
    },
    props: {
        allowInspectAggregatedData: Boolean,
        allowInspectRawData: Boolean,
        onDialogHidden: Function,
        onDialogShowing: Function,
        onDialogShown: Function,
        onGridContentReady: Function,
        onGridInitialized: Function
    }
});
DxDataInspector.$_optionName = "dataInspector";
const DxDataRequestOptions = createConfigurationComponent({
    emits: {
        "update:isActive": null,
        "update:hoveredElement": null,
        "update:itemDataLoadingMode": null,
        "update:itemDataRequestMode": null,
    },
    props: {
        itemDataLoadingMode: String,
        itemDataRequestMode: String
    }
});
DxDataRequestOptions.$_optionName = "dataRequestOptions";
const DxDataSourceWizard = createConfigurationComponent({
    emits: {
        "update:isActive": null,
        "update:hoveredElement": null,
        "update:allowCreateNewJsonConnection": null,
        "update:enableCustomSql": null,
        "update:onCustomizeDataSourceWizard": null,
        "update:wizardSettings": null,
    },
    props: {
        allowCreateNewJsonConnection: Boolean,
        enableCustomSql: Boolean,
        onCustomizeDataSourceWizard: Function,
        wizardSettings: Object
    }
});
DxDataSourceWizard.$_optionName = "dataSourceWizard";
DxDataSourceWizard.$_expectedChildren = {
    wizardSettings: { isCollectionItem: false, optionName: "wizardSettings" }
};
const DxDesignerToolbar = createConfigurationComponent({
    emits: {
        "update:isActive": null,
        "update:hoveredElement": null,
        "update:onPreparing": null,
    },
    props: {
        onPreparing: Function
    }
});
DxDesignerToolbar.$_optionName = "designerToolbar";
const DxExtensions = createConfigurationComponent({
    emits: {
        "update:isActive": null,
        "update:hoveredElement": null,
        "update:chartIndicators": null,
        "update:dashboardExport": null,
        "update:dashboardParameterDialog": null,
        "update:dataInspector": null,
        "update:dataSourceWizard": null,
        "update:designerToolbar": null,
        "update:itemBindingPanel": null,
        "update:itemOptionsPanel": null,
        "update:mobileLayout": null,
        "update:textBoxItemEditor": null,
        "update:viewerApi": null,
    },
    props: {
        chartIndicators: Object,
        dashboardExport: Object,
        dashboardParameterDialog: Object,
        dataInspector: Object,
        dataSourceWizard: Object,
        designerToolbar: Object,
        itemBindingPanel: Object,
        itemOptionsPanel: Object,
        mobileLayout: Object,
        textBoxItemEditor: Object,
        viewerApi: Object
    }
});
DxExtensions.$_optionName = "extensions";
DxExtensions.$_expectedChildren = {
    chartIndicators: { isCollectionItem: false, optionName: "chartIndicators" },
    dashboardExport: { isCollectionItem: false, optionName: "dashboardExport" },
    dashboardParameterDialog: { isCollectionItem: false, optionName: "dashboardParameterDialog" },
    dataInspector: { isCollectionItem: false, optionName: "dataInspector" },
    dataSourceWizard: { isCollectionItem: false, optionName: "dataSourceWizard" },
    designerToolbar: { isCollectionItem: false, optionName: "designerToolbar" },
    itemBindingPanel: { isCollectionItem: false, optionName: "itemBindingPanel" },
    itemOptionsPanel: { isCollectionItem: false, optionName: "itemOptionsPanel" },
    mobileLayout: { isCollectionItem: false, optionName: "mobileLayout" },
    textBoxItemEditor: { isCollectionItem: false, optionName: "textBoxItemEditor" },
    viewerApi: { isCollectionItem: false, optionName: "viewerApi" }
};
const DxFetchRemoteService = createConfigurationComponent({
    emits: {
        "update:isActive": null,
        "update:hoveredElement": null,
        "update:beforeSend": null,
        "update:headers": null,
    },
    props: {
        beforeSend: Function,
        headers: Object
    }
});
DxFetchRemoteService.$_optionName = "fetchRemoteService";
const DxItemBindingPanel = createConfigurationComponent({
    emits: {
        "update:isActive": null,
        "update:hoveredElement": null,
        "update:onCustomizeDataItemContainerSections": null,
    },
    props: {
        onCustomizeDataItemContainerSections: Function
    }
});
DxItemBindingPanel.$_optionName = "itemBindingPanel";
const DxItemOptionsPanel = createConfigurationComponent({
    emits: {
        "update:isActive": null,
        "update:hoveredElement": null,
        "update:onCustomizeSections": null,
    },
    props: {
        onCustomizeSections: Function
    }
});
DxItemOptionsPanel.$_optionName = "itemOptionsPanel";
const DxMobileLayout = createConfigurationComponent({
    emits: {
        "update:isActive": null,
        "update:hoveredElement": null,
        "update:mobileLayoutEnabled": null,
    },
    props: {
        mobileLayoutEnabled: String
    }
});
DxMobileLayout.$_optionName = "mobileLayout";
const DxTextBoxItemEditor = createConfigurationComponent({
    emits: {
        "update:isActive": null,
        "update:hoveredElement": null,
        "update:onRichEditCreated": null,
        "update:onRichEditOptionsPrepared": null,
    },
    props: {
        onRichEditCreated: Function,
        onRichEditOptionsPrepared: Function
    }
});
DxTextBoxItemEditor.$_optionName = "textBoxItemEditor";
const DxViewerApi = createConfigurationComponent({
    emits: {
        "update:isActive": null,
        "update:hoveredElement": null,
        "update:onDashboardTitleToolbarUpdated": null,
        "update:onItemActionAvailabilityChanged": null,
        "update:onItemCaptionToolbarUpdated": null,
        "update:onItemClick": null,
        "update:onItemDrillDownStateChanged": null,
        "update:onItemElementCustomColor": null,
        "update:onItemMasterFilterStateChanged": null,
        "update:onItemSelectionChanged": null,
        "update:onItemVisualInteractivity": null,
        "update:onItemWidgetCreated": null,
        "update:onItemWidgetOptionsPrepared": null,
        "update:onItemWidgetUpdated": null,
        "update:onItemWidgetUpdating": null,
        "update:onSelectedTabPageChanged": null,
    },
    props: {
        onDashboardTitleToolbarUpdated: Function,
        onItemActionAvailabilityChanged: Function,
        onItemCaptionToolbarUpdated: Function,
        onItemClick: Function,
        onItemDrillDownStateChanged: Function,
        onItemElementCustomColor: Function,
        onItemMasterFilterStateChanged: Function,
        onItemSelectionChanged: Function,
        onItemVisualInteractivity: Function,
        onItemWidgetCreated: Function,
        onItemWidgetOptionsPrepared: Function,
        onItemWidgetUpdated: Function,
        onItemWidgetUpdating: Function,
        onSelectedTabPageChanged: Function
    }
});
DxViewerApi.$_optionName = "viewerApi";
const DxWizardSettings = createConfigurationComponent({
    emits: {
        "update:isActive": null,
        "update:hoveredElement": null,
        "update:enableFederationDataSource": null,
        "update:enableJsonDataSource": null,
        "update:enableOlapDataSource": null,
        "update:enableSqlDataSource": null,
    },
    props: {
        enableFederationDataSource: Boolean,
        enableJsonDataSource: Boolean,
        enableOlapDataSource: Boolean,
        enableSqlDataSource: Boolean
    }
});
DxWizardSettings.$_optionName = "wizardSettings";
export default DxDashboardControl;
export { DxDashboardControl, DxAjaxRemoteService, DxChartIndicators, DxDashboardExport, DxDashboardParameterDialog, DxDataInspector, DxDataRequestOptions, DxDataSourceWizard, DxDesignerToolbar, DxExtensions, DxFetchRemoteService, DxItemBindingPanel, DxItemOptionsPanel, DxMobileLayout, DxTextBoxItemEditor, DxViewerApi, DxWizardSettings };
